import { Exclude, Expose } from 'class-transformer';
import { Industry } from 'src/enums/industry.enum';
import { RegulatoryElection } from 'src/enums/regulatory-election.enums';
import { ApplicationStatus, ObjectStatus } from 'src/enums/status.enum';
import { Resident } from 'src/resident/schemas/Resident.schema';

export class ApplicationInformationDto {
  @Exclude()
  _id: string;

  willWorkInPhysicalJuristiction: string;
  industry: Industry;
  regulatoryElection: RegulatoryElection;
  regulatoryElectionSub: string;
}

export class DecisionDto {
  @Exclude()
  _id: string;

  decidedAt: Date;
  rejctionReason: string;
}

export class GetRegisterIndustryChangeApplicationDto {
  @Expose({ name: 'id' })
  _id: string;

  @Exclude()
  resident: Resident;

  @Expose({ name: 'residentSub' })
  getResidentSub() {
    return this.resident.sub;
  }

  current: ApplicationInformationDto;
  requested: ApplicationInformationDto;
  status: ApplicationStatus;
  submittedAt: Date;
  decision: DecisionDto;
  objectStatus: ObjectStatus;
}
